diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index fa3bdb76e..6f9ac3165 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -1,108 +1,109 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard<T> {
     public BlockModelDoor(Block<T> block) {
         super(block);
     }
     
-    public void setBrightness(Tessellator tessellator, int x, int y, int z, float sideBrightness) {
+    public void setBrightness(Tessellator tessellator, WorldSource worldSource, int x, int y, int z, float sideBrightness) {
     	float brightness = sideBrightness;
     	if(LightmapHelper.isLightmapEnabled()) {
-    		tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+    		tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
     	}else {
-    		brightness *= renderBlocks.getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+    		brightness *= renderBlocks.getBlockBrightness(worldSource, x, y, z);
     	}
     	tessellator.setColorOpaque_F(brightness, brightness, brightness);
     }
     
     @Override
-	public boolean render(Tessellator tessellator, int x, int y, int z) {
+	public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
     	if(LightmapHelper.isLightmapEnabled()) {
     		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
     	}
     	tessellator.setColorOpaque_F(1.0f, 1.0f, 1.0f);
 
-		AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+		AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
 
 		float sideBottom = 1.0f;
 		float sideTop = 1.0f;
 		float sideNorthSouth = 1.0f;
 		float sideEastWest = 1.0f;
-		if(RenderBlocks.enableDirectionalLight) {
+		if(ENABLE_DIRECTIONAL_LIGHTING) {
 			sideBottom = 0.5f;
 			sideTop = 1.0f;
 			sideNorthSouth = 0.8f;
 			sideEastWest = 0.6f;
 		}
 		
-		boolean aboveIsDoor = Block.hasLogicClass(renderBlocks.blockAccess.getBlock(x, y + 1, z), BlockLogicDoor.class);
-		boolean belowIsDoor = Block.hasLogicClass(renderBlocks.blockAccess.getBlock(x, y - 1, z), BlockLogicDoor.class);
+		boolean aboveIsDoor = Block.hasLogicClass(worldSource.getBlock(x, y + 1, z), BlockLogicDoor.class);
+		boolean belowIsDoor = Block.hasLogicClass(worldSource.getBlock(x, y - 1, z), BlockLogicDoor.class);
 
-		int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+		int meta = worldSource.getBlockMetadata(x, y, z);
 		
 		// Bottom
 		if(!belowIsDoor) {
-			setBrightness(tessellator, x, y - 1, z, sideBottom);
-			renderBottomFace(tessellator, bounds, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.BOTTOM));
+			setBrightness(tessellator, worldSource, x, y - 1, z, sideBottom);
+			renderBlocks.renderBottomFace(tessellator, bounds, x, y, z, getBlockTexture(worldSource, x, y, z, Side.BOTTOM));
 		}
 		
 		// Top
 		if(!aboveIsDoor) {
-			setBrightness(tessellator, x, y + 1, z, sideTop);
-			renderTopFace(tessellator, bounds, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.TOP));
+			setBrightness(tessellator, worldSource, x, y + 1, z, sideTop);
+			renderBlocks.renderTopFace(tessellator, bounds, x, y, z, getBlockTexture(worldSource, x, y, z, Side.TOP));
 		}
 		
 		// North
-		if(bounds.minZ > RenderBlocks.FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, x, y, z, sideNorthSouth);
+		if(bounds.minZ > FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, worldSource, x, y, z, sideNorthSouth);
 		}else {
-			setBrightness(tessellator, x, y, z - 1, sideNorthSouth);
+			setBrightness(tessellator, worldSource, x, y, z - 1, sideNorthSouth);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.NORTH, meta);
-		IconCoordinate texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.NORTH);
-		renderNorthFace(tessellator, bounds, x, y, z, texture);
+		IconCoordinate texture = getBlockTexture(worldSource, x, y, z, Side.NORTH);
+		renderBlocks.renderNorthFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		
 		// South
-		if(bounds.maxZ < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, x, y, z, sideNorthSouth);
+		if(bounds.maxZ < 1.0f - FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, worldSource, x, y, z, sideNorthSouth);
 		}else {
-			setBrightness(tessellator, x, y, z + 1, sideNorthSouth);
+			setBrightness(tessellator, worldSource, x, y, z + 1, sideNorthSouth);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.SOUTH, meta);
-		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.SOUTH);
-		renderSouthFace(tessellator, bounds, x, y, z, texture);
+		texture = getBlockTexture(worldSource, x, y, z, Side.SOUTH);
+		renderBlocks.renderSouthFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		
 		// West
-		if(bounds.minX > RenderBlocks.FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, x, y, z, sideEastWest);
+		if(bounds.minX > FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, worldSource, x, y, z, sideEastWest);
 		}else {
-			setBrightness(tessellator, x - 1, y, z, sideEastWest);
+			setBrightness(tessellator, worldSource, x - 1, y, z, sideEastWest);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.WEST, meta);
-		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.WEST);
-		renderWestFace(tessellator, bounds, x, y, z, texture);
+		texture = getBlockTexture(worldSource, x, y, z, Side.WEST);
+		renderBlocks.renderWestFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		
 		// East
-		if(bounds.maxX < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
-			setBrightness(tessellator, x, y, z, sideEastWest);
+		if(bounds.maxX < 1.0f - FULL_CUBE_THRESHOLD) {
+			setBrightness(tessellator, worldSource, x, y, z, sideEastWest);
 		}else {
-			setBrightness(tessellator, x + 1, y, z, sideEastWest);
+			setBrightness(tessellator, worldSource, x + 1, y, z, sideEastWest);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.EAST, meta);
-		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.EAST);
-		renderEastFace(tessellator, bounds, x, y, z, texture);
+		texture = getBlockTexture(worldSource, x, y, z, Side.EAST);
+		renderBlocks.renderEastFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		return true;
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
index 8eca872ad..5e9e61c16 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelDoorPainted<T extends BlockLogicDoor> extends BlockModelDoor<T> {
     public static final IconCoordinate[] doorBottomTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
@@ -26,7 +27,7 @@ public class BlockModelDoorPainted<T extends BlockLogicDoor> extends BlockModelD
         this.isTop = isTop;
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int color = (data >> 4) & DyeColor.MASK_COLOR;
         if (side.getAxis() == Axis.Y){
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
index 8c01dacce..1c3644656 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
@@ -5,6 +5,8 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelEmpty<T extends BlockLogic> extends BlockModelStandard<T> {
@@ -13,17 +15,17 @@ public class BlockModelEmpty<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         return false;
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
 
     }
 
     @Override
-    public IconCoordinate getParticleTexture(Side side, int meta) {
+    public @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta) {
         return null;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
index f15b2aa0a..d3e746ab6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
@@ -6,8 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicFarmland;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFarmland<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate topWet = TextureRegistry.getTexture("minecraft:block/farmland/wet_top");
@@ -21,7 +20,7 @@ public class BlockModelFarmland<T extends BlockLogic> extends BlockModelStandard
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, final int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, final int data)
     {
         boolean isWet = BlockLogicFarmland.isWet(data);
         boolean isFertilized = BlockLogicFarmland.isFertilized(data);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 28346c6b2..4b1b4ccf9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -6,35 +6,43 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStandard<T> {
+    protected static final DisplayPos FENCE_GUI = new DisplayPos(0, 0, 0, 30, 225 - 90, 0, 0.625f, 0.625f, 0.625f);
+    protected static final DisplayPos FENCE_HEAD = new DisplayPos(0, 0, 0, 0, 90, 0, 1f, 1f, 1f);
     public BlockModelFence(Block<T> block) {
         super(block);
+
+        setDisplayPos(DisplayPos.GUI, FENCE_GUI);
+        setDisplayPos(DisplayPos.HEAD, FENCE_HEAD);
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         final float f = 0.375F;
         final float f1 = 0.625F;
         AABB bounds = AABB.getTemporaryBB(f, 0.0F, f, f1, 1.0F, f1);
-        renderStandardBlock(tessellator, bounds, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         boolean flag1 = false;
         boolean flag2 = false;
         BlockLogicFence fence = block.getLogic();
-        if(fence.canConnectTo(renderBlocks.blockAccess, x - 1, y, z) || fence.canConnectTo(renderBlocks.blockAccess, x + 1, y, z))
+        if(fence.canConnectTo(worldSource, x - 1, y, z) || fence.canConnectTo(worldSource, x + 1, y, z))
         {
             flag1 = true;
         }
-        if(fence.canConnectTo(renderBlocks.blockAccess, x, y, z - 1) || fence.canConnectTo(renderBlocks.blockAccess, x, y, z + 1))
+        if(fence.canConnectTo(worldSource, x, y, z - 1) || fence.canConnectTo(worldSource, x, y, z + 1))
         {
             flag2 = true;
         }
-        boolean flag3 = fence.canConnectTo(renderBlocks.blockAccess, x - 1, y, z);
-        boolean flag4 = fence.canConnectTo(renderBlocks.blockAccess, x + 1, y, z);
-        boolean flag5 = fence.canConnectTo(renderBlocks.blockAccess, x, y, z - 1);
-        boolean flag6 = fence.canConnectTo(renderBlocks.blockAccess, x, y, z + 1);
+        boolean flag3 = fence.canConnectTo(worldSource, x - 1, y, z);
+        boolean flag4 = fence.canConnectTo(worldSource, x + 1, y, z);
+        boolean flag5 = fence.canConnectTo(worldSource, x, y, z - 1);
+        boolean flag6 = fence.canConnectTo(worldSource, x, y, z + 1);
         if(!flag1 && !flag2)
         {
             flag1 = true;
@@ -50,33 +58,33 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
         if(flag1)
         {
             bounds.set(f4, f2, f8, f5, f3, f9);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if(flag2)
         {
             bounds.set(f8, f2, f6, f9, f3, f7);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         final float f10 = 0.375F;
         final float f11 = 0.5625F;
         if(flag1)
         {
             bounds.set(f4, f10, f8, f5, f11, f9);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         if(flag2)
         {
             bounds.set(f8, f10, f6, f9, f11, f7);
-            renderStandardBlock(tessellator, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         }
         return true;
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint)
         {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
             float r = (float)(color >> 16 & 0xff) / 255F;
             float g = (float)(color >> 8 & 0xff) / 255F;
             float b = (float)(color & 0xff) / 255F;
@@ -109,32 +117,32 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, -1F, 0.0F);
-            renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+            renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
-            renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+            renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
-            renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+            renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
-            renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+            renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
-            renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+            renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
-            renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+            renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
             tessellator.draw();
         }
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
